/*=============================================================================/
/                                                                              /
/                           PPIvOCETvP                          /
/                                                                              /
/                         Palette Operator PPI-Plugin SDK                      /
/               Copyright (C)2005 Advangate. All rights reserved.              /
/------------------------------------------------------------------------------/
/ TvP                                                                 /
/      KvŒ̋@\TvB                                    /
/      P̃pbgP̉摜݂̂̃[hAZ[usB                  /
/=============================================================================*/
#include <memory.h>
#include <stdio.h>
#include "..\..\..\include\PalOpePlgin.h"


/*=============================================================================/
/                            t@CtH[}bg`                          /
/------------------------------------------------------------------------------/
/ t@CtH[}bg\                                                   /
/                                                  /
/      wb_                                                              /
/        FmtSmp1   (16oCg)                                              /
/                                                  /
/      pbgJ[f[^     <-- CfbNXJ[̏ꍇ̂ݑ݂B /
/                                                  /
/      摜f[^                                                          /
/                                                  /
/=============================================================================*/
#define		FMTSMP1_SIG_VAL			(0x31504d53)			/* VOl` "SMP1" */

typedef struct {
	Uint32		Sig;										/* VOl`l */
	Uint8		Type;										/* 摜^Cv 0:_CNgJ[  1:CfbNXJ[ */
	Uint8		Alpha;										/* At@`lLȏꍇ 1 */
	Uint16		PalColNum;									/* CfbNXJ[̏ꍇ̃pbgJ[ */
	Uint16		Width;										/* 摜TCYi) */
	Uint16		Height;										/* 摜TCYi) */
	Uint32		_reserved_[1];								/* U[u(0) */
} FmtSmp1;


/*=============================================================================/
/                              vOCf[^                            /
/=============================================================================*/
/* -------- vV[WID` -------- */
#define PRCID_LOAD		0									/* [hpvV[WID */
#define PRCID_SAVE		1									/* Z[upvV[WID */

/* -------- vOCf[^ -------- */
PpiPluginInfoData plginInfDt = 
	PLGIFDATA(
		"PPIvOCETvP",						/* vOC */
		"Copyright (C) 2005 Advangate. Ver 1.00"			/* o[WRs[Cg\p */
	);

/* -------- vV[Wf[^ -------- */
PpiProcInfoData procInfDt[] = {
	/* [hpvV[W */
	PRCIFDATA_LOAD(
		PRCID_LOAD,											/* vV[WIDԍ */
		"SMP1tH[}bg[_",							/* vV[W */
		PRCIDCAPS_IMAGE_DIR | PRCIDCAPS_IMAGE_IDX | PRCIDCAPS_ALPHA, /* \̓tO (PRCIDCAPS_` Œ`ꂽl) */
		"vOCTvSMP1",							/* tB^[ */
		"*.smp1"											/* tB^[p^[ */
	),
	/* Z[upvV[W */
	PRCIFDATA_SAVE(
		PRCID_SAVE,											/* vV[WIDԍ */
		"SMP1tH[}bgZ[o",							/* vV[W */
		PRCIDCAPS_IMAGE_DIR | PRCIDCAPS_IMAGE_IDX | PRCIDCAPS_ALPHA, /* \̓tO (PRCIDCAPS_` Œ`ꂽl) */
		"vOCTvSMP1",							/* tB^[ */
		"*.smp1"											/* tB^[p^[ */
	),
	
	/* I[ */
	PRCIFDATA_TERM()
};


/*=============================================================================/
/                                ckkC                              /
/------------------------------------------------------------------------------/
/ DLL̃Gg|CgB                                                      /
/=============================================================================*/
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	return TRUE;
}


/*=============================================================================/
/                                vOC̐ڑ                              /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPlgContext* plgctx       : vOCReLXg                   /
/       PpiPluginInfoData** plgifdt : vOCf[^i[               /
/       PpiProcInfoData** prcifdt   : vV[Wf[^i[             /
/ ret.                                                                         /
/       BOOL     : TRUE ̏ꍇ͐ڑBFALSE ̏ꍇ͐ڑsB             /
/------------------------------------------------------------------------------/
/ vOC̊ezXgAvP[VɓnAvOCƐڑsB   /
/ FALSE ԂƃzXgł̃vOCgpȂB                         /
/=============================================================================*/
PPIEXPT BOOL PPIAPI PpiConnectPlugin(PpiPlgContext* plgctx, PpiPluginInfoData** plgifdt, PpiProcInfoData** prcifdt)
{
	*plgifdt = &plginInfDt;									/* vOCf[^ */
	*prcifdt = procInfDt;									/* vV[Wf[^ */

	return TRUE;
}


/*=============================================================================/
/                                vOC̐ؒf                              /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPlgContext* plgctx       : vOCReLXg                   /
/------------------------------------------------------------------------------/
/ vOCƂ̐ڑؒfOɌĂяoB                               /
/=============================================================================*/
//PPIEXPT void PPIAPI PpiDisconnectPlugin(PpiPlgContext* plgctx)
//{
//}


/*=============================================================================/
/                               vV[W̐ڑ                             /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/ ret.                                                                         /
/       BOOL     : TRUE ̏ꍇ͐ڑBFALSE ̏ꍇ͐ڑsB             /
/------------------------------------------------------------------------------/
/ vV[WƂ̐ڑɌĂяoBKvȂ΃vV[W̏sB /
/ FALSE ԂꍇÃvV[WgpȂB                           /
/=============================================================================*/
//PPIEXPT BOOL PPIAPI PpiConnectProc(PpiPrcContext* prctx)
//{
//	return TRUE;
//}


/*=============================================================================/
/                               vV[W̐ؒf                             /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/------------------------------------------------------------------------------/
/ vV[WƂ̐ڑؒfOɌĂяoB                             /
/=============================================================================*/
//PPIEXPT void PPIAPI PpiDisconnectProc(PpiPrcContext* prctx)
//{
//}


/*=============================================================================/
/                                  AoEg\                                /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPlgContext* plgctx       : vOCReLXg                   /
/------------------------------------------------------------------------------/
/ o[WRs[Cg\_CAO\鏈B               /
/ svȏꍇ͊֐̂̎sȂ悤ɂB                             /
/=============================================================================*/
//PPIEXPT void PPIAPI PpiDispAbout(PpiPlgContext* plgctx)
//{
//}


/*=============================================================================/
/                        t@C[hp̃IvVݒ                      /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiFileInf* fileinf         : t@Cp[^                   /
/ ret.                                                                         /
/       PpiErr   : G[ԍ                                                  /
/------------------------------------------------------------------------------/
/ t@C[hvV[WŃt@C̃[hOɃIvVݒsB       /
/=============================================================================*/
//PPIEXPT PpiErr PPIAPI PpiFileLoadOptions(PpiPrcContext* prctx, PpiFileInf* fileinf)
//{
//	return PPIERR_OK;
//}


/*=============================================================================/
/                         t@C[h̑Ή`FbN                       /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiFileInf* fileinf         : t@Cp[^                   /
/ ret.                                                                         /
/       BOOL     : TRUE ̏ꍇ͑Ή\BFALSE ̏ꍇ͑ΉȂB           /
/------------------------------------------------------------------------------/
/ fileinf Ŏꂽt@C͑Ήt@C`FbNsB               /
/ Ήꍇ TRUE ԂAΉłȂꍇ FALSE ԂB                /
/=============================================================================*/
PPIEXPT BOOL PPIAPI PpiFileLoadChkSupport(PpiPrcContext* prctx, PpiFileInf* fileinf)
{
	const FmtSmp1*	header = (FmtSmp1*)(fileinf->FileHeadBuf);

	/* VOl`̃`FbN */
	if(header->Sig != FMTSMP1_SIG_VAL){
		return FALSE;
	}

	/* Ή摜^Cv`FbN */
	if((header->Type != 0) && (header->Type != 1)){
		return FALSE;
	}

	/* Ή\ȃtH[}bg */
	return TRUE;
}


/*=============================================================================/
/                  t@C[h̃t@C̓ǂݏo                /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiFileInf* fileinf         : t@Cp[^                   /
/ ret.                                                                         /
/       PpiErr   : G[ԍ                                                  /
/------------------------------------------------------------------------------/
/ t@C̓ǂݏo̖{́B                                           /
/ Ńt@Cf[^ǂݏozXg摜f[^Ɋi[B               /
/ [hꍇ PPIERR_OK ԂAG[Lꍇ͂ȊOԂB  /
/=============================================================================*/
PPIEXPT PpiErr PPIAPI PpiFileLoadExec(PpiPrcContext* prctx, PpiFileInf* fileinf)
{
	PpiErr res;
	FILE* fp = NULL;
	PpiHostPict* php = &prctx->HostPict;
	FmtSmp1	header;
	Uint32 i, size;

	Uint32 flg;
	PpiImgType type;
	Uint32 w;
	Uint32 h;
	Uint32 mmc;
	Uint32 palbnkc;
	Uint32 palcolc;

	/* -------- t@CJ -------- */
	if((fp = fopen(fileinf->FileName, "rb")) == NULL){
		/* t@CJȂ */
		res = PPIERR_FILE_ERR;
		goto __FINAL_POINT;
	}
	/* vOX */
	if(PpiHaProgress(prctx, 0)){
		/* [U[ɂLZ */
		res = PPIERR_CANCELED;
		goto __FINAL_POINT;
	}

	/* -------- wb_ǂݏo -------- */
	if(fread(&header, 1, sizeof(header), fp) != sizeof(header)){
		/* wb_̓ǂݏos */
		res = PPIERR_FILE_ERR;
		goto __FINAL_POINT;
	}
	/* pbgJ[킩`FbN */
	if(header.Type == 1){									/* CfbNXJ[摜̏ꍇ */
		if(header.PalColNum == 0){
			/* pbgJ[݂Ȃ */
			res = PPIERR_DATA_BROKEN;
			goto __FINAL_POINT;
		}
	}
	/* 摜TCY킩`FbN */
	if((header.Width == 0) || (header.Height == 0)){
		res = PPIERR_DATA_BROKEN;
		goto __FINAL_POINT;
	}

	/* -------- zXg摜쐬 -------- */
	/* p[^߂ */
	flg = 0;
	type = PPIIMGTP_DIRECT;
	w = header.Width;
	h = header.Height;
	mmc = 1;
	palbnkc = 0;
	palcolc = 0;
	if(header.Alpha){
		/* At@`lĂ */
		flg |= PPIHSTIG_FLG_ALPHA;
	}
	if(header.Type == 1){
		/* CfbNXJ[摜 */
		type = PPIIMGTP_INDEX;
		palbnkc = 1;
		palcolc = header.PalColNum;
	}
	/* zXg摜쐬 */
	res = PpiHaCreateHostPict(prctx, flg, type, w, h, mmc, palbnkc, palcolc);
	if(res != PPIERR_OK){
		/* zXg摜̍쐬Ɏs */
		goto __FINAL_POINT;
	}

	/* -------- pbg̓ǂݏo -------- */
	if(type == PPIIMGTP_INDEX){
		Uint8 col[4];
		PpiRGBA* pal = php->PalData[0].PalBuf;
		size = (header.Alpha)? 4 : 3;						/* PF̃TCY */
		for(i = 0; i < php->PalColCnt; i++, pal++){
			/* pbĝPFǂݏo */
			if(fread(col, 1, size, fp) != size){
				/* pbg̓ǂݏos */
				res = PPIERR_DATA_BROKEN;
				goto __FINAL_POINT;
			}
			/* PFi[ */
			pal->r = col[0];
			pal->g = col[1];
			pal->b = col[2];
			if(header.Alpha){
				pal->a = col[3];
			}
		}
	}

	/* -------- 摜̓ǂݏo -------- */
	if(type == PPIIMGTP_DIRECT){
		/* _CNgJ[摜ǂݏo */
		PpiRGBA* img = php->ImgData[0].ImgBufDir;
		size = (header.Alpha)? 4 : 3;						/* PsNZ̃TCY */
		for(i = 0; i < h; i++){
			/* PCǂݏo */
			Uint8 pix[4];
			Uint32 x;
			for(x = 0; x < w; x++, img++){
				/* PsNZǂݏo */
				if(fread(pix, 1, size, fp) != size){
					/* 摜̓ǂݏos */
					res = PPIERR_DATA_BROKEN;
					goto __FINAL_POINT;
				}
				/* PsNZi[ */
				img->r = pix[0];
				img->g = pix[1];
				img->b = pix[2];
				if(header.Alpha){
					img->a = pix[3];
				}
			}
			/* vOX */
			if(PpiHaProgress(prctx, 100*i/h)){
				/* [U[ɂLZ */
				res = PPIERR_CANCELED;
				goto __FINAL_POINT;
			}
		}
	} else {
		/* CfbNXJ[摜ǂݏo */
		PpiIDXCOL* img = php->ImgData[0].ImgBufIdx;
		size = 1;											/* PsNZ̃TCY */
		for(i = 0; i < h; i++){
			/* PCǂݏo */
			Uint8 pix[1];
			Uint32 x;
			for(x = 0; x < w; x++, img++){
				/* PsNZǂݏo */
				if(fread(pix, 1, size, fp) != size){
					/* 摜̓ǂݏos */
					res = PPIERR_DATA_BROKEN;
					goto __FINAL_POINT;
				}
				/* PsNZi[ */
				img->idx = pix[0];
			}
			/* vOX */
			if(PpiHaProgress(prctx, 100*i/h)){
				/* [U[ɂLZ */
				res = PPIERR_CANCELED;
				goto __FINAL_POINT;
			}
		}
	}

	/* ---- ǂݏo ---- */
	PpiHaProgress(prctx, 100);
	res = PPIERR_OK;

	/* -------- I -------- */
__FINAL_POINT:
	if(fp){
		fclose(fp);
	}
	return res;
}


/*=============================================================================/
/                        t@CZ[up̃IvVݒ                      /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiFileInf* fileinf         : t@Cp[^                   /
/ ret.                                                                         /
/       PpiErr   : G[ԍ                                                  /
/------------------------------------------------------------------------------/
/ t@CZ[uvV[WŃt@C̃Z[uOɃIvVݒsB       /
/=============================================================================*/
//PPIEXPT PpiErr PPIAPI PpiFileSaveOptions(PpiPrcContext* prctx, PpiFileInf* fileinf)
//{
//	return PPIERR_OK;
//}


/*=============================================================================/
/                      t@CZ[ũt@C֕ۑ                    /
/------------------------------------------------------------------------------/
/ prm.                                                                         /
/       PpiPrcContext* prctx        : vV[WReLXg                 /
/       PpiFileInf* fileinf         : t@Cp[^                   /
/ ret.                                                                         /
/       PpiErr   : G[ԍ                                                  /
/------------------------------------------------------------------------------/
/ t@Cւ̕ۑ̖{́B                                                 /
/ ŃzXg摜f[^̏t@CɕۑB                           /
/ Z[uꍇ PPIERR_OK ԂAG[Lꍇ͂ȊOԂB  /
/=============================================================================*/
PPIEXPT PpiErr PPIAPI PpiFileSaveExec(PpiPrcContext* prctx, PpiFileInf* fileinf)
{
	PpiErr res;
	FILE* fp = NULL;
	PpiHostPict* php = &prctx->HostPict;
	FmtSmp1	header;
	Uint32 i, size;

	PpiPalData* paldat;
	PpiImgData* imgdat;

	/* -------- wb_쐬 -------- */
	memset(&header, 0, sizeof(header));
	header.Sig = FMTSMP1_SIG_VAL;
	if(php->Type == PPIIMGTP_INDEX){
		/* CfbNXJ[摜̏ꍇ */
		header.Type = 1;									/* CfbNXJ[ */
		header.PalColNum = php->PalColCnt;					/* CfbNXJ[̏ꍇ̃pbgJ[ */
		paldat = &php->PalData[prctx->DispPalBnk];			/* ݕ\̃pbgoNۑΏۂɂ */
	}
	if(php->Flag & PPIHSTIG_FLG_ALPHA){
		header.Alpha = 1;									/* At@`l͗L */
	}
	imgdat = &php->ImgData[prctx->DispMmlv];				/* ݕ\̃~bv}bvx摜ۑΏۂɂ */
	header.Width = imgdat->Width;
	header.Height = imgdat->Height;

	/* -------- t@CJ -------- */
	if((fp = fopen(fileinf->FileName, "wb")) == NULL){
		/* t@CJȂ */
		res = PPIERR_FILE_ERR;
		goto __FINAL_POINT;
	}
	/* vOX */
	if(PpiHaProgress(prctx, 0)){
		/* [U[ɂLZ */
		res = PPIERR_CANCELED;
		goto __FINAL_POINT;
	}

	/* -------- wb_ۑ -------- */
	if(fwrite(&header, 1, sizeof(header), fp) != sizeof(header)){
		/* os */
		res = PPIERR_FILE_ERR;
		goto __FINAL_POINT;
	}

	/* -------- pbgۑ -------- */
	if(header.Type == 1){
		Uint8 col[4];
		const PpiRGBA* pal = paldat->PalBuf;
		size = (header.Alpha)? 4 : 3;						/* PF̃TCY */
		for(i = 0; i < php->PalColCnt; i++, pal++){
			/* pbĝPF擾 */
			col[0] = pal->r;
			col[1] = pal->g;
			col[2] = pal->b;
			if(header.Alpha){
				col[3] = pal->a;
			}
			/* pbĝPFۑ */
			if(fwrite(col, 1, size, fp) != size){
				/* os */
				res = PPIERR_FILE_ERR;
				goto __FINAL_POINT;
			}
		}
	}

	/* -------- 摜ۑ -------- */
	if(header.Type == 0){
		/* _CNgJ[摜ۑ */
		const PpiRGBA* img = imgdat->ImgBufDir;
		size = (header.Alpha)? 4 : 3;						/* PsNZ̃TCY */
		for(i = 0; i < header.Height; i++){
			/* PCۑ */
			Uint8 pix[4];
			Uint32 x;
			for(x = 0; x < header.Width; x++, img++){
				/* PsNZ擾 */
				pix[0] = img->r;
				pix[1] = img->g;
				pix[2] = img->b;
				if(header.Alpha){
					pix[3] = img->a;
				}
				/* PsNZۑ */
				if(fwrite(pix, 1, size, fp) != size){
					/* 摜̕ۑɎs */
					res = PPIERR_FILE_ERR;
					goto __FINAL_POINT;
				}
			}
			/* vOX */
			if(PpiHaProgress(prctx, 100*i/header.Height)){
				/* [U[ɂLZ */
				res = PPIERR_CANCELED;
				goto __FINAL_POINT;
			}
		}
	} else {
		/* CfbNXJ[摜ۑ */
		const PpiIDXCOL* img = imgdat->ImgBufIdx;
		size = 1;											/* PsNZ̃TCY */
		for(i = 0; i < header.Height; i++){
			/* PCۑ */
			Uint8 pix[1];
			Uint32 x;
			for(x = 0; x < header.Width; x++, img++){
				/* PsNZ擾 */
				pix[0] = img->idx;
				/* PsNZۑ */
				if(fwrite(pix, 1, size, fp) != size){
					/* 摜̕ۑɎs */
					res = PPIERR_FILE_ERR;
					goto __FINAL_POINT;
				}
			}
			/* vOX */
			if(PpiHaProgress(prctx, 100*i/header.Height)){
				/* [U[ɂLZ */
				res = PPIERR_CANCELED;
				goto __FINAL_POINT;
			}
		}
	}

	/* ---- o ---- */
	PpiHaProgress(prctx, 100);
	res = PPIERR_OK;

	/* -------- I -------- */
__FINAL_POINT:
	if(fp){
		fclose(fp);
	}
	return res;
}


